# My Dotfiles

These are my dotfiles in a silo repo. Silo is a dotfile manager I've written that allows for config files
to be treated as handlebar templates when they end in `.tmpl`. So the config files in these folders are
applied differently depending on the system and installed programs on the system.

## Applying the configuration

Run

```nu
silo init https://git.trivernis.net/Trivernis/dotfiles-silo
````
to pull the repository into the default silo directory at `~/.local/share/silo`
on Unix or `~/AppData/Roaming/silo` on Windows.

Now run

```nu
silo apply
```

To apply the configuration. If you're using `nix` with `home-manager` you need
to run `silo apply` a second time because the newly installed packages (using the home-manager hook in `~/hooks/home-manager.nu`)
will change how the configuration is applied.

So on `apply` this repo does

1. Update the context variables in `~/.config/silo.toml` and prompts for input on required variables.
2. Renders the templates and moves the resulting configurations to the configured directories
3. Runs `home-manager` to automatically install packages. Additionally deletes older hm-generations and clears the cache
